//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include <clipbrd.hpp>

#include "Unit1.h"
#include "Unit4.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm4 *Form4;
//---------------------------------------------------------------------------
__fastcall TForm4::TForm4(TComponent* Owner)
	: TForm(Owner)
{
}


extern  TBitmap *bmp;
extern int Cut_Flg;

TRect rect;
POINT points[2],pnt[2];

TShiftState SL,SR;
int Flg,Mx,My,DragFlg;
int CutX,CutY;

 void Mod_Clear(int flg=0)
{
 points[1].x=0;
 points[1].y=0;
 points[0].x=0;
 points[0].y=0;

}


 void line(int Img_flg=0)
{
	 Form4->Image1->Canvas->MoveTo(points[0].x,points[0].y);
	 Form4->Image1->Canvas->LineTo(points[1].x,points[0].y);
	 Form4->Image1->Canvas->LineTo(points[1].x,points[1].y);
	 Form4->Image1->Canvas->LineTo(points[0].x,points[1].y);
	 Form4->Image1->Canvas->LineTo(points[0].x,points[0].y);
}


void line_start(int X,int Y,int img_flg=0)
{

 Form4->Image1->Canvas->Pen->Mode=pmNot;

 if(Flg==0)
  {
   Flg=255;

   if((points[1].x !=0)||(points[1].y !=0))
	 {   line(img_flg);    }

   points[0].x=X;
   points[0].y=Y;
   points[1].x=X;
   points[1].y=Y;

   Form4->Image1->Canvas->MoveTo(points[0].x,points[0].y);
  }
}

 void cut()
{
   int w,h,tmp;
   TRect rect0,rect1;

   w=points[1].x-points[0].x;
   h=points[1].y-points[0].y;

   rect0.top=points[0].y+1;
   rect0.left=points[0].x+1;
   rect0.bottom=points[1].y;
   rect0.right=points[1].x;

   if(rect0.top>rect0.bottom)
    { tmp=rect0.top; rect0.top=rect0.bottom; rect0.bottom=tmp; }

   if(rect0.left>rect0.right)
    { tmp=rect0.left; rect0.left=rect0.right; rect0.right=tmp; }

   bmp->Width=abs(w);
   bmp->Height=abs(h);

   bmp->Canvas->CopyRect(Rect(0,0,abs(w),abs(h)),Form4->Image1->Picture->Bitmap->Canvas,rect0);

}

//-----;----------------------------------------------------------------------
void __fastcall TForm4::Button1Click(TObject *Sender)
{
 Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm4::FormActivate(TObject *Sender)
{
  int h,w;

  Form4->Width=500+30;

  SL<<ssLeft;
  SR<<ssRight;

  w=500;
  h=500.0*bmp->Height/(float)bmp->Width;

  Form4->Height=h+Panel1->Height+50;

  rect.left=5;
  rect.Top=5;
  rect.right=w+5;
  rect.Bottom=h+5;

  Image1->Canvas->StretchDraw(rect,bmp);

  Mod_Clear();

}
//---------------------------------------------------------------------------
void __fastcall TForm4::Image1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{
  int w,h,p,i,ii,x,y;

 Mx=X;
 My=Y;

 if(mbRight==Button)
  {   return;  }

 if((Flg>0)&&(Flg<45))
  {
   DragFlg=1;
   Form4->Image1->Canvas->Pen->Mode=pmNot;
  }

 if(Flg==0)
  {
   if(SL==Shift)
	{
	 CutX=X;
	 CutY=Y;
	 line_start(X,Y);

	 Screen->Cursor=crCross;
	}
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm4::Image1MouseUp(TObject *Sender, TMouseButton Button, TShiftState Shift,
		  int X, int Y)
{

  int x0,y0,x1,y1;

  if(mbRight==Button)    return;

  Screen->Cursor=crArrow;
  Image1->Canvas->Pen->Mode=pmNop;
  Flg=0;
  DragFlg=0;


  if(((points[1].x-points[0].x) !=0)&&((points[1].y-points[0].y) !=0))
   {

	x0=points[0].x;     y0=points[0].y;
	x1=points[1].x;     y1=points[1].y;

	if(x0>x1)
	 { points[0].x=x1;points[1].x=x0; }

	if(y0>y1)
	 { points[0].y=y1; points[1].y=y0; }
   }
 Button2->Enabled=true;

}

//---------------------------------------------------------------------------

int Pos(int x,int y)
{
 int x0,x1,y0,y1;

 if(points[0].x==points[1].x) return 0;

 if((x<points[0].x)||(x>=points[1].x)||(y<points[0].y)||(y>points[1].y))
  { Screen->Cursor=crArrow; return 0; } //I͈͊O


 if((x>=points[0].x)&& (x<=points[0].x+10))
	{
	 if((y>=points[0].y)&&(y<=points[0].y+10))
	  {
	   Screen->Cursor=crSizeNWSE;
	   return 1;
	  }
	 if((y<=points[1].y)&&(y>=points[1].y-10))
	  {
		Screen->Cursor=crSizeNESW;
		 return 4;   }
	  }

 if((x<=points[1].x) &&(x>=points[1].x-10) )
   {
	if((y>=points[0].y) &&  (y<=points[0].y+10))
	 {
	   Screen->Cursor=crSizeNESW;
	   return 2;
	 }
	if((y<=points[1].y)&&(y>=points[1].y-10))
	 {
		Screen->Cursor=crSizeNWSE;
		return 3;
	 }
  }

 if((x>=points[0].x)&&(x<points[1].x-10))
  {
   if((y>=points[0].y)&&(y<=points[0].y+10))
	{
	  Screen->Cursor=crSizeNS;
	  return 11;
	}
   if((y<=points[1].y)&&(y>=points[1].y-10))
	{
	  Screen->Cursor=crSizeNS;
	  return 33;
	}
  }
 if((y>=points[0].y)&&(y<=points[1].y-10))
  {
   if((x>=points[0].x)&&(x<=points[0].x+10))
	{
	  Screen->Cursor=crSizeWE;
	  return 44;
	}
   if((x<=points[1].x)&&(x>=points[1].x-10))
	{
	  Screen->Cursor=crSizeWE;
	  return 22;
	}
  }

 //I͈͓
 Screen->Cursor=crHandPoint;
 return 5;
}


void Set_Cut(int X,int Y)
{
	CutX=points[1].x-points[0].x;
    CutY=points[1].y-points[0].y;

	Mx=X;
	My=Y;
}



void Sub_Hani(TShiftState Shift, int X, int Y,int img_flg=0)
{
 int x,y;

 if(SL==Shift)
  {
   line(img_flg);

   x=X-Mx;
   y=Y-My;

   switch(Flg)
   {
    case 255:
     points[1].x=X;
     points[1].y=Y;
     CutX=X-points[0].x;
     CutY=Y-points[0].y;

     break;

    case 1: //p
     points[0].x=points[0].x+x;
     points[0].y=points[0].y+y;
	 Set_Cut(X,Y);
     break;
	case 2: //Ep
     points[1].x=points[1].x+x;
     points[0].y=points[0].y+y;
     Set_Cut(X,Y);
     break;
    case 3: //Ep
     points[1].x=points[1].x+x;
     points[1].y=points[1].y+y;
     Set_Cut(X,Y);

     break;
    case 4: //p
     points[0].x=points[0].x+x;
     points[1].y=points[1].y+y;

     Set_Cut(X,Y);
     break;
    case 11: //
     points[0].y=points[0].y+y;
     Set_Cut(X,Y);
     break;

    case 22: //E
     points[1].x=points[1].x+x;
     Set_Cut(X,Y);
     break;
    case 33: //
     points[1].y=points[1].y+y;
     Set_Cut(X,Y);
     break;
    case 44: //
     points[0].x=points[0].x+x;
	 Set_Cut(X,Y);
     break;
    case 5:  //ړ
      points[0].x=points[0].x+x;
      points[1].x=points[1].x+x;

      points[0].y=points[0].y+y;
      points[1].y=points[1].y+y;

      Mx=X;
      My=Y;

     break;

    defauilt:
    break;
   }

  line(img_flg);

  if(img_flg==0)
   {
    if(CutX<0) CutX=CutX*-1;
    if(CutY<0) CutY=CutY*-1;
   }
 }


}
//---------------------------------------------------------------------------

void __fastcall TForm4::Image1MouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y)
{
 int x,y,p,pos;

 if((Flg !=255)&&(DragFlg ==0))
   {
	Flg=Pos(X,Y);
   }

 Sub_Hani(Shift, X, Y);
}

//---------------------------------------------------------------------------

void __fastcall TForm4::Button2Click(TObject *Sender)
{
 cut();
 Cut_Flg=255;
}
//---------------------------------------------------------------------------

